/* $Header: /home/cvsroot/c/vadcrit/vadcritcz.c,v 2.4 2005/09/15 10:37:12 milan Exp $ */

/* SOUBOR: VADCRITCZ.C  - Ceska verze
** POPIS : 
**         Porovnava realny vystup detektoru s referencnm. 
**         Vstupni data jsou ulozena v souboru ve formatu ASCII 
**         (0 ... pauza; 1 ... recova aktivita).
**         Program se spousti se dvema povinnymi parametry. 
**         Prvni parametr "soubor1" udava jmeno souboru, ktery obsahuje vystup realneho detektoru,
**         druhy parametr "soubor2" udava jmeno souboru, ktery obsahuje referencni detekci.
**         Dale se muze zadat 34 volitelnych parametru, ktere urcuji format zobrazeni kriterii a volbu kriterii.
*/

#include <stdio.h>                     
#include <stdlib.h>
#include <string.h>

static char cvsId[] = "(#) $Header: /home/cvsroot/c/vadcrit/vadcritcz.c,v 2.4 2005/09/15 10:37:12 milan Exp $";
static char cvsRevision[] = "$Revision: 2.4 $";

#define FALSE    0  
#define TRUE    -1  

#define PRIZNAK_1_CHYBY   4
#define PRIZNAK_2_CHYBY   2
#define PRIZNAK_3_CHYBY   1

#define MAX_POCET_PARAMETRU  37
#define MIN_POCET_PARAMETRU   3

#define POCET_TYPU_CHYB         23
#define ZACATEK_DRUHU_CHYB       3
#define POCET_DRUHU_CHYB        10
#define ZACATEK_PRUMERNYCH_CHYB 13
#define POCET_PRUMERNYCH_CHYB   10
#define PARAMETR_err    0          
#define PARAMETR_ers    1          
#define PARAMETR_erp    2
#define PARAMETR_nds    3
#define PARAMETR_sdn    4
#define PARAMETR_mis    5
#define PARAMETR_min    6
#define PARAMETR_ovb    7
#define PARAMETR_ovf    8
#define PARAMETR_trb    9
#define PARAMETR_trf   10
#define PARAMETR_bee   11
#define PARAMETR_res   12

#define PARAMETR_ands  13
#define PARAMETR_asdn  14
#define PARAMETR_amis  15
#define PARAMETR_amin  16
#define PARAMETR_aovb  17
#define PARAMETR_aovf  18
#define PARAMETR_atrb  19
#define PARAMETR_atrf  20
#define PARAMETR_abee  21
#define PARAMETR_ares  22

#define PARAMETR_a     0
#define PARAMETR_p     1
#define PARAMETR_r     2

#define PARAMETR_s     0
#define PARAMETR_ms    1

int FormatVystupu = PARAMETR_r;    // Nastavi format vystupu chyb
int FormatCasu    = PARAMETR_ms;   // Nastavi format casu prodlevy

typedef struct {
                int   Poradi;     // Urci poradi vypisu v zavislosti na poradi v prikazove radce
                char *Nazev;      // Nazev chyby
                int   APchyb;     // Absolutni Pocet chyb
                float RPchyb;     // Relativni pocet chyb
               } Chyby;

Chyby Chyba[POCET_TYPU_CHYB];      // Pole obsahujici informace o typech chyb
int   TypChyby = 0;                // Urci druh chyby

int   AChyby[POCET_TYPU_CHYB + 1]; // Serazene pole absolutnich chyb podle prikazove radky
float RChyby[POCET_TYPU_CHYB + 1]; // Serazene pole relativnich chyb podle prikazove radky

int VyskytChyb[POCET_PRUMERNYCH_CHYB]; // Obsahuje pocet vyskytu dane chyby

char *originalVAD    = NULL;  // Jmeno referencniho souboru
char *vystupVAD      = NULL;  // Vystup detektoru
int Parametr_a       = FALSE; // Zobrazi se absolutni hodnoty chyb
int Parametr_d       = FALSE; // Umoznuje vypis detailnejsiho vypisu
int Parametr_p       = FALSE; // Zobrazi se chyby v procentech
int Parametr_r       = FALSE; // Zobrazi se relativni hodnoty chyb
int Parametr_err     = FALSE; // Zobrazi se celkovy pocet chyb
int Parametr_ers     = FALSE; // Zobrazi se pocet chyb v reci
int Parametr_erp     = FALSE; // Zobrazi se pocet chyb v pauze
int Parametr_nds     = FALSE; // Zobrazi se typ chyby NDS
int Parametr_sdn     = FALSE; // Zobrazi se typ chyby SDN
int Parametr_mis     = FALSE; // Zobrazi se typ chyby MIS
int Parametr_min     = FALSE; // Zobrazi se typ chyby MIN
int Parametr_ovb     = FALSE; // Zobrazi se typ chyby OVB
int Parametr_ovf     = FALSE; // Zobrazi se typ chyby OVF
int Parametr_trb     = FALSE; // Zobrazi se typ chyby TRB
int Parametr_trf     = FALSE; // Zobrazi se typ chyby TRF
int Parametr_bee     = FALSE; // Zobrazi se typ chyby BEE, ktera se vyskytuje na primo na zacatku a konci zpravy BEE
int Parametr_res     = FALSE; // Zobrazi se typ chyby RES, vystup detektoru je presne opacny, nez referencni

int Parametr_ands    = FALSE; // Zobrazi se prumerna chyba NDS
int Parametr_asdn    = FALSE; // Zobrazi se prumerna chyba SDN
int Parametr_amis    = FALSE; // Zobrazi se prumerna chyba MIS
int Parametr_amin    = FALSE; // Zobrazi se prumerna chyba MIN
int Parametr_aovb    = FALSE; // Zobrazi se prumerna chyba OVB
int Parametr_aovf    = FALSE; // Zobrazi se prumerna chyba OVF
int Parametr_atrb    = FALSE; // Zobrazi se prumerna chyba TRB
int Parametr_atrf    = FALSE; // Zobrazi se prumerna chyba TRF
int Parametr_abee    = FALSE; // Zobrazi se prumerna chyba BEE
int Parametr_ares    = FALSE; // Zobrazi se prumerna chyba RES

int Parametr_fs      = FALSE; // Nastavi frekvenci vzorkovani, prevracena hodnota urcuje dobu trvani jednoho vzorku.
                              // k parametru fs se musi napsat frekvence v Hz, tato hodnota zvetsuje pocet parametru o 1
int Parametr_ms      = FALSE; // Urcuje, zda cas bude v ms    
int Parametr_s       = FALSE; // Urcuje, zda cas bude v s

int Parametr_ae      = FALSE; // Zobrazi se prumerna hodnota chyb  
int Parametr_de      = FALSE; // Zobrazi se doba prumerne chyby v sekundach nebo v milisekundach

int Parametr_all     = FALSE; // Zobrazi se vsechny typy chyb

int   ChybaBEE       = FALSE; // Oznamuje, zda se vyskytla chyba BEE
int   ChybaRES       = FALSE; // Oznamuje, zda se vyskytla chyba RES
float ParametrFS     = 0;     // Frekvence vzorkovani, prevracena hodnota urcuje dobu trvani 1 vzorku /// double je presnejsi  

int pvVAD;            // Obsahuje predchozi znak ze souboru detektoru 
int oVAD;             // Obsahuje znak z referencniho souboru
int poVAD;            // Obsahuje predchozi znak z referencniho souboru
int vVAD;             // Obsahuje znak ze souboru detektoru

int   Cpocet    = 0;  // Celkovy pocet znaku

FILE *ForiginalVAD;   // Datovy proud referencniho souboru
FILE *FvystupVAD;     // Datovy proud souboru detektoru

int a = 1; // Promenna "a" obsahuje maximalni pocet parametru, jejich hodnoty se zobrazi na obrazovku.

int  JeCislo(char *c);         // Zjisti, zda je retez cislo v dekadickem nebo exponencialnim tvaru
void KorekcePchyb();           // Zajisti to, ze se zobrazi bud jen prumerne hodnoty chyb a nebo doby trvani prumernych chyb
void NaplnPoleChyb();          // Naplni pole moznymi typy chyb a pole chybnych rozhodnuti
void SeradAChyby();            // Seradi absolutni chyby do pole podle prikazove radky
void SeradRChyby();            // Seradi relativni chyby do pole podle prikazove radky
void SmazPoleChyb();           // Vybuluje pole chyb + pole rozhodnuti
void UrciARchyby();            // Urci Absolutni a Relativni chyby
void UrciPchyby();             // Urci prumerne chyby
void ZobrazArgumenty();        // Zobrazi vsechny parametry programu a jejich spravny format
void ZobrazChybyAbsolutne();   // Zobrazi chyby v absolutnim tvaru
void ZobrazChybyVProcentech(); // Zobrazi chyby v procentech
void ZobrazChybyRelativne();   // Zobrazi chyby v relativnim tvaru
void ZobrazVerziProgramu();    // Zobrazi verzi programu

/***********************************************************************************************************/

int main(int argc, char **argv)
{
 int qq;

 if ((argc < MIN_POCET_PARAMETRU) || (argc > MAX_POCET_PARAMETRU)) ZobrazArgumenty();

 vystupVAD   = argv[1];
 originalVAD = argv[2];

 NaplnPoleChyb();

 if (argc > MIN_POCET_PARAMETRU)
   {
    for (qq = MIN_POCET_PARAMETRU; qq < argc; qq++)
       {
        if ((strcmp(argv[qq], "-a")   == 0) && (!Parametr_a))
          {
           Parametr_a    = TRUE;
           FormatVystupu = PARAMETR_a;
          }
        else if ((strcmp(argv[qq], "-d")   == 0) && (!Parametr_d))   
          {
           Parametr_d   = TRUE;
          }
        else if ((strcmp(argv[qq], "-p")   == 0) && (!Parametr_p))  
          {
           Parametr_p    = TRUE;
           FormatVystupu = PARAMETR_p;
          }
        else if ((strcmp(argv[qq], "-r")   == 0) && (!Parametr_r))   
          {
           Parametr_r    = TRUE;
           FormatVystupu = PARAMETR_r;
          }
        else if ((strcmp(argv[qq], "-err") == 0) && (!Parametr_err))
          {
           Parametr_err = TRUE;
           Chyba[PARAMETR_err].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-ers") == 0) && (!Parametr_ers))
          {
           Parametr_ers = TRUE;
           Chyba[PARAMETR_ers].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-erp") == 0) && (!Parametr_erp))
          {
           Parametr_erp = TRUE;
           Chyba[PARAMETR_erp].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-nds") == 0) && (!Parametr_nds)) 
          {
           Parametr_nds = TRUE;
           Chyba[PARAMETR_nds].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-sdn") == 0) && (!Parametr_sdn)) 
          {
           Parametr_sdn = TRUE;
           Chyba[PARAMETR_sdn].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-mis") == 0) && (!Parametr_mis))
          {
           Parametr_mis = TRUE;
           Chyba[PARAMETR_mis].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-min") == 0) && (!Parametr_min))
          {
           Parametr_min = TRUE;
           Chyba[PARAMETR_min].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-ovb") == 0) && (!Parametr_ovb)) 
          {
           Parametr_ovb = TRUE;
           Chyba[PARAMETR_ovb].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-ovf") == 0) && (!Parametr_ovf)) 
          {
           Parametr_ovf = TRUE;
           Chyba[PARAMETR_ovf].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-trb") == 0) && (!Parametr_trb)) 
          {
           Parametr_trb = TRUE;
           Chyba[PARAMETR_trb].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-trf") == 0) && (!Parametr_trf)) 
          {
           Parametr_trf = TRUE;
           Chyba[PARAMETR_trf].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-bee") == 0) && (!Parametr_bee)) 
          {
           Parametr_bee = TRUE;
           Chyba[PARAMETR_bee].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-res") == 0) && (!Parametr_res)) 
          {
           Parametr_res = TRUE;
           Chyba[PARAMETR_res].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-ands") == 0) && (!Parametr_ands)) 
          {
           Parametr_ands = TRUE;
           Chyba[PARAMETR_ands].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-asdn") == 0) && (!Parametr_asdn)) 
          {
           Parametr_asdn = TRUE;
           Chyba[PARAMETR_asdn].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-amis") == 0) && (!Parametr_amis))
          {
           Parametr_amis = TRUE;
           Chyba[PARAMETR_amis].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-amin") == 0) && (!Parametr_amin))
          {
           Parametr_amin = TRUE;
           Chyba[PARAMETR_amin].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-aovb") == 0) && (!Parametr_aovb)) 
          {
           Parametr_aovb = TRUE;
           Chyba[PARAMETR_aovb].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-aovf") == 0) && (!Parametr_aovf)) 
          {
           Parametr_aovf = TRUE;
           Chyba[PARAMETR_aovf].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-atrb") == 0) && (!Parametr_atrb)) 
          {
           Parametr_atrb = TRUE;
           Chyba[PARAMETR_atrb].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-atrf") == 0) && (!Parametr_atrf)) 
          {
           Parametr_atrf = TRUE;
           Chyba[PARAMETR_atrf].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-abee") == 0) && (!Parametr_abee)) 
          {
           Parametr_abee = TRUE;
           Chyba[PARAMETR_abee].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-ares") == 0) && (!Parametr_ares)) 
          {
           Parametr_ares = TRUE;
           Chyba[PARAMETR_ares].Poradi = a;
           a++;
          }
        else if ((strcmp(argv[qq], "-fs") == 0) && (!Parametr_fs)) 
          {
           Parametr_fs = TRUE;
           qq++;               // Nasledujici parametr musi byt ciselna hodnota frekvence
           if (qq < argc) ParametrFS = atof(argv[qq]);
           if ((ParametrFS <= 0) || (!JeCislo(argv[qq])) || (qq >= argc))
             {
              fprintf(stderr, "Spatne zadana frekvence fs: %s. Frekvence nesmi byt zaporna nebo nulova !\n", argv[qq]);
              exit(1);
             }
          }
        else if ((strcmp(argv[qq], "-ms") == 0) && (!Parametr_ms)) 
          {
           Parametr_ms = TRUE;
           FormatCasu = PARAMETR_ms;
          }
        else if ((strcmp(argv[qq], "-s") == 0) && (!Parametr_s)) 
          {
           Parametr_s = TRUE;
           FormatCasu = PARAMETR_s;
          }
        else if ((strcmp(argv[qq], "-ae") == 0) && (!Parametr_ae)) 
          {
           Parametr_ae = TRUE;
           Parametr_de = FALSE;
          }
        else if ((strcmp(argv[qq], "-de") == 0) && (!Parametr_de)) 
          {
           Parametr_de = TRUE;
           Parametr_ae = FALSE;
          }
        else if ((strcmp(argv[qq], "-all") == 0) && (!Parametr_all))
          {
           Parametr_all = TRUE;
          }
        else ZobrazArgumenty();
       }
   }

 if ((ForiginalVAD = fopen(originalVAD, "rt")) == NULL)
   {
    fprintf(stderr,"Soubor (referencni) %s nelze otevrit, zrejme neexistuje !!!\n", originalVAD);
    exit(1);
   }

 if ((FvystupVAD = fopen(vystupVAD, "rt")) == NULL)
   {
    fprintf(stderr, "Soubor (vystup detektoru) %s nelze otevrit, zrejme neexistuje !!!\n", vystupVAD);
    exit(1);
   }

 while ((oVAD != EOF) || (vVAD != EOF))
      {
       poVAD = oVAD; // Zachovani predchozi hodnoty oVAD
       pvVAD = vVAD; // Zachovava predchozi hodnoty vVAD
       oVAD  = getc(ForiginalVAD);
       vVAD  = getc(FvystupVAD);

       while ((oVAD == 10) || (oVAD == 13)) // 10d -> 0Ah -> LF -> '\n'  ////////////////////
            {
             oVAD = getc(ForiginalVAD); // Konec radku
            }
       while ((vVAD == 10) || (vVAD == 13)) // 13d -> 0Dh -> CR -> '\r' /////////////////////
            {
             vVAD = getc(FvystupVAD);
            }
       if ((oVAD != EOF) && (vVAD != EOF) && (oVAD > 32) && (vVAD > 32))    //////////////////
         { // Nepocita se s prvnimi 32 znaky ASCII tabulky
          if ((oVAD != 48) && (oVAD != 49)) // 48d -> 30h -> '0'
            {
             fprintf(stderr, "Spatny format dat souboru %s, data musi obsahovat pouze znaky '0' nebo '1'\n",
                     originalVAD);
             exit(1);
            }
          if ((vVAD != 48) && (vVAD != 49)) // 49d -> 31h -> '1'
            {
             fprintf(stderr, "Spatny format dat souboru %s, data musi obsahovat pouze znaky '0' nebo '1'\n",
                     vystupVAD);
             exit(1);
            }
          Cpocet++;
          if (oVAD != vVAD) // Soubory se v danem miste lisi 
            {
             if (oVAD == 48) Chyba[PARAMETR_erp].APchyb++;  //  Lisi se v pauze
             Chyba[PARAMETR_err].APchyb++; // V teto casti slouzi jako pomocna promenna, urcuje pocet chyb daneho kriteria

             if ((pvVAD != vVAD) && (Chyba[PARAMETR_err].APchyb != 1))
               { // Vznikla chyba RES
                ChybaRES = TRUE;
               }
             if (Cpocet == 1)
               { // Chyba na uplnem zacatku zpravy
                ChybaBEE = TRUE;
               }
             else
               {
                if (poVAD == 49) TypChyby = TypChyby | PRIZNAK_1_CHYBY;  // Bitovy soucet
                if (vVAD  == 49) TypChyby = TypChyby | PRIZNAK_2_CHYBY;
               }
            }
          else
            {
             if (ChybaBEE)
               { // Chyba na uplnem zacatku zpravy
                ChybaBEE = FALSE;
                Chyba[PARAMETR_bee].APchyb = Chyba[PARAMETR_err].APchyb;
                VyskytChyb[PARAMETR_bee - ZACATEK_DRUHU_CHYB]++;
                Chyba[PARAMETR_err].APchyb = 0;
                TypChyby = 0;
               }
             else if (ChybaRES)
               {
                ChybaRES = FALSE;
                Chyba[PARAMETR_res].APchyb = Chyba[PARAMETR_err].APchyb;
                VyskytChyb[PARAMETR_res - ZACATEK_DRUHU_CHYB]++;
                Chyba[PARAMETR_err].APchyb = 0;
                TypChyby = 0;
               }

             if (Chyba[PARAMETR_err].APchyb != 0)
               {
                if (oVAD == 49) TypChyby = TypChyby | PRIZNAK_3_CHYBY;

                switch (TypChyby)
                      {
                       case 0: // Chyba cislo 3 - MISS
                              Chyba[PARAMETR_mis].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_mis - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 1: // Chyba cislo 4 - TRF
                              Chyba[PARAMETR_trf].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_trf - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 2: // Chyba cislo 1 - NDS
                              Chyba[PARAMETR_nds].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_nds - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 3: // Chyba cislo 2 - OVF
                              Chyba[PARAMETR_ovf].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_ovf - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 4: // Chyba cislo 7 - TRB
                              Chyba[PARAMETR_trb].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_trb - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 5: // Chyba cislo 8 - SDN
                              Chyba[PARAMETR_sdn].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_sdn - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 6: // Chyba cislo 5 - OVB
                              Chyba[PARAMETR_ovb].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_ovb - ZACATEK_DRUHU_CHYB]++;
                              break;
                       case 7: // Chyba cislo 6 - MIN
                              Chyba[PARAMETR_min].APchyb += Chyba[PARAMETR_err].APchyb;
                              VyskytChyb[PARAMETR_min - ZACATEK_DRUHU_CHYB]++;
                              break;
                      default: // Typ chyby se neurcil
                              fprintf(stderr, "POZOR ! NEZJISTIL SE TYP CHYBY !!!");
                              exit(1);
                      }
                Chyba[PARAMETR_err].APchyb = 0;
                TypChyby = 0;
               }
            }
         }
      }

 if (Chyba[PARAMETR_err].APchyb != 0) 
   { // Chyba na uplnem konci zpravy
    Chyba[PARAMETR_bee].APchyb += Chyba[PARAMETR_err].APchyb;
    VyskytChyb[PARAMETR_bee - ZACATEK_DRUHU_CHYB]++;
    Chyba[PARAMETR_err].APchyb = 0;
   }

 if ((oVAD != EOF) && (vVAD != EOF))
   {
    fprintf(stderr, "!!! POZOR !!!\nSoubory %s a %s jsou ruzne velike !!!\n", originalVAD, vystupVAD);
    exit(1);
   }

 if (fclose(ForiginalVAD) == -1)
   {
    fprintf(stderr, "Soubor (referencni) %s nelze zavrit !!!\n", originalVAD);
    exit(1);
   } 

 if (fclose(FvystupVAD) == -1)
   {
    fprintf(stderr, "Soubor (vystup detektoru) %s nelze zavrit !!!\n", vystupVAD);
    exit(1);
   } 

 if (Parametr_de)
   {
    if ((!Parametr_fs) && (!Parametr_d))
      {
       fprintf(stderr, "Pro urceni dob trvani prumernych chyb (parametr -de), se musi zadat vzorkovaci frekvence (-fs frekvence) !!!\n");
       exit(1);
      }
   }

 UrciARchyby();
 UrciPchyby();

 if (Parametr_d)
   {
    fprintf(stdout, "Vystup detektoru VAD: %s\n", vystupVAD);
    fprintf(stdout, "Originalni vystup   : %s\n\n", originalVAD);
    fprintf(stdout, "ERR: %8.3f%% %5i\n", Chyba[PARAMETR_err].RPchyb, Chyba[PARAMETR_err].APchyb);
    fprintf(stdout, "\nERS: %8.3f%% %5i", Chyba[PARAMETR_ers].RPchyb, Chyba[PARAMETR_ers].APchyb);
    fprintf(stdout, "\nERP: %8.3f%% %5i\n\n", Chyba[PARAMETR_erp].RPchyb, Chyba[PARAMETR_erp].APchyb);

    if (Parametr_fs)
      {
       fprintf(stdout, " fs: %8.3fHz\n\n", ParametrFS);
      }

    for (qq = ZACATEK_DRUHU_CHYB; qq < ZACATEK_PRUMERNYCH_CHYB; qq++)
       {
        fprintf(stdout, "%s: %8.3f%% %5i %8s: %5i", Chyba[qq].Nazev, Chyba[qq].RPchyb, Chyba[qq].APchyb,
                        Chyba[qq + POCET_PRUMERNYCH_CHYB].Nazev, 
                        Chyba[qq + POCET_PRUMERNYCH_CHYB].APchyb);

        if (Parametr_fs)
          {
           if (FormatCasu == PARAMETR_s) fprintf(stdout, "%8.3fs\n", Chyba[qq + POCET_PRUMERNYCH_CHYB].RPchyb); 
           else fprintf(stdout, "%11.3fms\n", Chyba[qq + POCET_PRUMERNYCH_CHYB].RPchyb); 
          }
        else fprintf(stdout, "\n");
       }
   }
 else
   {
    if ((!Parametr_ae) && (!Parametr_de)) Parametr_ae = TRUE; // Implicitni nastaveni

    SmazPoleChyb();

    if ((!Parametr_err) && (!Parametr_ers) && (!Parametr_erp) && (!Parametr_nds) && (!Parametr_sdn) &&
        (!Parametr_mis) && (!Parametr_min) && (!Parametr_ovb) && (!Parametr_ovf) && 
        (!Parametr_trb) && (!Parametr_trf) && (!Parametr_bee) && (!Parametr_res) &&
        (!Parametr_ands) && (!Parametr_asdn) && (!Parametr_amis) && (!Parametr_amin) && (!Parametr_aovb) && 
        (!Parametr_aovf) && (!Parametr_atrb) && (!Parametr_atrf) && (!Parametr_abee) && (!Parametr_ares))
      { // Implicitni nastaveni, program se chova, jako po zadani parametru -err -ers -erp
       Chyba[PARAMETR_err].Poradi = 1;
       Chyba[PARAMETR_ers].Poradi = 2;
       Chyba[PARAMETR_erp].Poradi = 3;
       a = 4;
      }

    if ((!Parametr_a) && (!Parametr_p) && (!Parametr_r)) 
      {
       Parametr_r = TRUE;
       FormatVystupu = PARAMETR_r;
      }

    KorekcePchyb();
    SeradAChyby();
    SeradRChyby();

    switch (FormatVystupu)
          {
           case PARAMETR_a: 
                           ZobrazChybyAbsolutne();
                           break;
           case PARAMETR_p:
                           // ZobrazChybyVProcentech();
                           // break;
           case PARAMETR_r:
                           ZobrazChybyRelativne();
                           break;
           default: 
                   ZobrazChybyRelativne();
                   break;
          }
   }

 return 0;
}

/***********************************************************************************************************
* Funkce: int JeCislo(char *c)
* Popis :
*         Zjisti, zda je retez (parametr c) cislo v dekadickem nebo exponencialnim tvaru.
*/
int JeCislo(char *c)
{
 unsigned int q;
 int e = FALSE, E = FALSE, t = FALSE;

 for (q = 0; q < strlen(c); q++)
    {
     if (((c[q] >= '0') && (c[q] <= '9')) || (c[q] == '.') || (c[q] == 'e') || (c[q] == 'E') || (c[q] == '-') || (c[q] == '+'))
       {
        if ((c[q] == '-') && (q != 0) && (c[q - 1] != 'e') && (c[q - 1] != 'E')) return FALSE;
        if ((c[q] == '+') && (q != 0) && (c[q - 1] != 'e') && (c[q - 1] != 'E')) return FALSE;
        if ((c[q] == '.') && (!t)) t = TRUE;
        else if ((c[q] == '.') && (t)) return FALSE;
        if ((c[q] == 'e') && (!e)) e = TRUE;
        else if ((c[q] == 'e') && (e)) return FALSE;
        if ((c[q] == 'E') && (!E)) E = TRUE;
        else if ((c[q] == 'E') && (E)) return FALSE;
       }
     else return FALSE;
    }
 return TRUE;
}

/***********************************************************************************************************
* Funkce: void KorekcePchyb()
* Popis :
*         Zajisti to, ze se zobrazi bud jen prumerne hodnoty chyb a nebo doby trvani prumernych chyb.
*/
void KorekcePchyb()
{
 int q;

 if (Parametr_ae)
   {
    for (q = ZACATEK_PRUMERNYCH_CHYB; q < (ZACATEK_PRUMERNYCH_CHYB + POCET_PRUMERNYCH_CHYB); q++)
       {
        Chyba[q].RPchyb = -1;
       }
   }
 if (Parametr_de)
   {
    for (q = ZACATEK_PRUMERNYCH_CHYB; q < (ZACATEK_PRUMERNYCH_CHYB + POCET_PRUMERNYCH_CHYB); q++)
       {
        Chyba[q].APchyb = -1;
       }
   }
}

/***********************************************************************************************************
* Funkce: void NaplnPoleChyb()
* Popis :
*         Naplni pole moznymi typy chyb a pole chybnych rozhodnuti.
*/
void NaplnPoleChyb()
{
 int q;

 Chyba[PARAMETR_err].Poradi = 0;
 Chyba[PARAMETR_err].Nazev  = "ERR";
 Chyba[PARAMETR_err].APchyb = 0;
 Chyba[PARAMETR_err].RPchyb = 0;

 Chyba[PARAMETR_ers].Poradi = 0;
 Chyba[PARAMETR_ers].Nazev  = "ERS";
 Chyba[PARAMETR_ers].APchyb = 0;
 Chyba[PARAMETR_ers].RPchyb = 0;

 Chyba[PARAMETR_erp].Poradi = 0;
 Chyba[PARAMETR_erp].Nazev  = "ERP";
 Chyba[PARAMETR_erp].APchyb = 0;
 Chyba[PARAMETR_erp].RPchyb = 0;

 Chyba[PARAMETR_nds].Poradi = 0;
 Chyba[PARAMETR_nds].Nazev  = "NDS";
 Chyba[PARAMETR_nds].APchyb = 0;
 Chyba[PARAMETR_nds].RPchyb = 0;

 Chyba[PARAMETR_sdn].Poradi = 0;
 Chyba[PARAMETR_sdn].Nazev  = "SDN";
 Chyba[PARAMETR_sdn].APchyb = 0;
 Chyba[PARAMETR_sdn].RPchyb = 0;

 Chyba[PARAMETR_mis].Poradi = 0;
 Chyba[PARAMETR_mis].Nazev  = "MIS";
 Chyba[PARAMETR_mis].APchyb = 0;
 Chyba[PARAMETR_mis].RPchyb = 0;

 Chyba[PARAMETR_min].Poradi = 0;
 Chyba[PARAMETR_min].Nazev  = "MIN";
 Chyba[PARAMETR_min].APchyb = 0;
 Chyba[PARAMETR_min].RPchyb = 0;

 Chyba[PARAMETR_ovb].Poradi = 0;
 Chyba[PARAMETR_ovb].Nazev  = "OVB";
 Chyba[PARAMETR_ovb].APchyb = 0;
 Chyba[PARAMETR_ovb].RPchyb = 0;

 Chyba[PARAMETR_ovf].Poradi = 0;
 Chyba[PARAMETR_ovf].Nazev  = "OVF";
 Chyba[PARAMETR_ovf].APchyb = 0;
 Chyba[PARAMETR_ovf].RPchyb = 0;

 Chyba[PARAMETR_trb].Poradi = 0;
 Chyba[PARAMETR_trb].Nazev  = "TRB";
 Chyba[PARAMETR_trb].APchyb = 0;
 Chyba[PARAMETR_trb].RPchyb = 0;

 Chyba[PARAMETR_trf].Poradi = 0;
 Chyba[PARAMETR_trf].Nazev  = "TRF";
 Chyba[PARAMETR_trf].APchyb = 0;
 Chyba[PARAMETR_trf].RPchyb = 0;

 Chyba[PARAMETR_bee].Poradi = 0;
 Chyba[PARAMETR_bee].Nazev  = "BEE";
 Chyba[PARAMETR_bee].APchyb = 0;
 Chyba[PARAMETR_bee].RPchyb = 0;

 Chyba[PARAMETR_res].Poradi = 0;
 Chyba[PARAMETR_res].Nazev  = "RES";
 Chyba[PARAMETR_res].APchyb = 0;
 Chyba[PARAMETR_res].RPchyb = 0;

 Chyba[PARAMETR_ands].Poradi = 0;
 Chyba[PARAMETR_ands].Nazev  = "ANDS";
 Chyba[PARAMETR_ands].APchyb = 0;
 Chyba[PARAMETR_ands].RPchyb = 0;

 Chyba[PARAMETR_asdn].Poradi = 0;
 Chyba[PARAMETR_asdn].Nazev  = "ASDN";
 Chyba[PARAMETR_asdn].APchyb = 0;
 Chyba[PARAMETR_asdn].RPchyb = 0;

 Chyba[PARAMETR_amis].Poradi = 0;
 Chyba[PARAMETR_amis].Nazev  = "AMIS";
 Chyba[PARAMETR_amis].APchyb = 0;
 Chyba[PARAMETR_amis].RPchyb = 0;

 Chyba[PARAMETR_amin].Poradi = 0;
 Chyba[PARAMETR_amin].Nazev  = "AMIN";
 Chyba[PARAMETR_amin].APchyb = 0;
 Chyba[PARAMETR_amin].RPchyb = 0;

 Chyba[PARAMETR_aovb].Poradi = 0;
 Chyba[PARAMETR_aovb].Nazev  = "AOVB";
 Chyba[PARAMETR_aovb].APchyb = 0;
 Chyba[PARAMETR_aovb].RPchyb = 0;

 Chyba[PARAMETR_aovf].Poradi = 0;
 Chyba[PARAMETR_aovf].Nazev  = "AOVF";
 Chyba[PARAMETR_aovf].APchyb = 0;
 Chyba[PARAMETR_aovf].RPchyb = 0;

 Chyba[PARAMETR_atrb].Poradi = 0;
 Chyba[PARAMETR_atrb].Nazev  = "ATRB";
 Chyba[PARAMETR_atrb].APchyb = 0;
 Chyba[PARAMETR_atrb].RPchyb = 0;

 Chyba[PARAMETR_atrf].Poradi = 0;
 Chyba[PARAMETR_atrf].Nazev  = "ATRF";
 Chyba[PARAMETR_atrf].APchyb = 0;
 Chyba[PARAMETR_atrf].RPchyb = 0;

 Chyba[PARAMETR_abee].Poradi = 0;
 Chyba[PARAMETR_abee].Nazev  = "ABEE";
 Chyba[PARAMETR_abee].APchyb = 0;
 Chyba[PARAMETR_abee].RPchyb = 0;

 Chyba[PARAMETR_ares].Poradi = 0;
 Chyba[PARAMETR_ares].Nazev  = "ARES";
 Chyba[PARAMETR_ares].APchyb = 0;
 Chyba[PARAMETR_ares].RPchyb = 0;

 for (q = 0; q < POCET_PRUMERNYCH_CHYB; q++)
    {
     VyskytChyb[q] = 0;
    }
}

/***********************************************************************************************************
* Funkce: void SeradAChyby()
* Popis :
*         Seradi absolutni chyby do pole podle prikazove radky.
*/
void SeradAChyby()
{
 int q;
 int A;

 for (q = 0; q < POCET_TYPU_CHYB; q++)
    {
     AChyby[Chyba[q].Poradi] = Chyba[q].APchyb;
    }
 for (A = a; A <= (POCET_TYPU_CHYB + 1); A++)
    {
     AChyby[A] = 0;
    }
}

/***********************************************************************************************************
* Funkce: void SeradRChyby()
* Popis :
*         Seradi relativni chyby do pole podle prikazove radky.
*/
void SeradRChyby()
{
 int q;
 int A;

 for (q = 0; q < POCET_TYPU_CHYB; q++)
    {
     RChyby[Chyba[q].Poradi] = Chyba[q].RPchyb;
    }
 for (A = a; A <= (POCET_TYPU_CHYB + 1); A++)
    {
     RChyby[A] = 0;
    }
}

/***********************************************************************************************************
* Funkce: void SmazPoleChyb()
* Popis :
*         Vynuluje pole chyb + pole rozhodnuti.
*/
void SmazPoleChyb()
{
 int q;

 for (q = 0; q < POCET_TYPU_CHYB + 1; q++)
    {
     AChyby[q] = -1;
     RChyby[q] = -1;
    }
}

/***********************************************************************************************************
* Funkce: void UrciARchyby()
* Popis :
*         Urci Absolutni a Relativni chyby.
*/
void UrciARchyby()
{
 int q;

 Chyba[PARAMETR_err].APchyb = 0; // Ted s ni skutecne pracujeme
 for (q = ZACATEK_DRUHU_CHYB; q < (ZACATEK_DRUHU_CHYB + POCET_DRUHU_CHYB); q++)
    {
     Chyba[PARAMETR_err].APchyb += Chyba[q].APchyb;
     Chyba[q].RPchyb = Chyba[q].APchyb;
     Chyba[q].RPchyb /= Cpocet;
    }

 Chyba[PARAMETR_err].RPchyb  = Chyba[PARAMETR_err].APchyb;
 Chyba[PARAMETR_err].RPchyb /= Cpocet;
 Chyba[PARAMETR_erp].RPchyb  = Chyba[PARAMETR_erp].APchyb;
 Chyba[PARAMETR_erp].RPchyb /= Cpocet;
 Chyba[PARAMETR_ers].APchyb  = Chyba[PARAMETR_err].APchyb - Chyba[PARAMETR_erp].APchyb;
 Chyba[PARAMETR_ers].RPchyb  = Chyba[PARAMETR_err].RPchyb - Chyba[PARAMETR_erp].RPchyb;

 if ((Parametr_p) || (Parametr_d))
   {
    for (q = PARAMETR_err; q < ZACATEK_PRUMERNYCH_CHYB; q++) Chyba[q].RPchyb *= 100;
   }
}

/***********************************************************************************************************
* Funkce: void UrciPchyby()
* Popis :
*         Urci prumerne chyby.
*/
void UrciPchyby()
{
 int q;

 for (q = 0; q < POCET_PRUMERNYCH_CHYB; q++)
    {
     if (VyskytChyb[q] != 0) 
       {
        Chyba[q + ZACATEK_PRUMERNYCH_CHYB].APchyb  = Chyba[ZACATEK_DRUHU_CHYB + q].APchyb / VyskytChyb[q];
        Chyba[q + ZACATEK_PRUMERNYCH_CHYB].RPchyb  = Chyba[q + ZACATEK_PRUMERNYCH_CHYB].APchyb;
        Chyba[q + ZACATEK_PRUMERNYCH_CHYB].RPchyb /= ParametrFS;
        if (FormatCasu == PARAMETR_ms)
          {
           Chyba[q + ZACATEK_PRUMERNYCH_CHYB].RPchyb *= 1000;
          }
       }
     else
       {
        Chyba[q + ZACATEK_PRUMERNYCH_CHYB].APchyb = 0;
        Chyba[q + ZACATEK_PRUMERNYCH_CHYB].RPchyb = 0;
       }
    }
}

/***********************************************************************************************************
* Funkce: void ZobrazArgumenty()
* Popis :
*         Zobrazi vsechny parametry programu a jejich spravny format.
*/
void ZobrazArgumenty()
{
 ZobrazVerziProgramu();
 fprintf(stderr, "\nZADAL JSI SPATNY TVAR NEBO POCET NEBO SE ARGUMENTY OPAKUJI.\n");
 fprintf(stderr, "   vadcritcz soubor1 soubor2 [-d | [-a | -r | -p] [-ae | -de -fs frekvence [-ms | -s]]\n");
 fprintf(stderr, "   [-all | [-err] [-ers] [-erp] [-nds] [-sdn] [-mis] [-min] [-ovb] [-ovf] [-trb] [-trf] [-bee] [-res]\n");
 fprintf(stderr, "   [-ands] [-asdn] [-amis] [-amin] [-aovb] [-aovf] [-atrb] [-atrf] [-abee] [-ares]]]\n");
 fprintf(stderr, "POVINNE PARAMETRY:\n");
 fprintf(stderr, "   soubor1 ... Vystup realneho detektoru - ASCII soubor.\n");
 fprintf(stderr, "   soubor2 ... Referencni detekce - ASCII soubor.\n");
 fprintf(stderr, "VOLITELNE PARAMETRY:\n");
 fprintf(stderr, "      -d ... Zobrazi se detailni vypis.\n");
 fprintf(stderr, "   FORMAT CHYB:\n");
 fprintf(stderr, "      -a ... Program zobrazi absolutni chybu.\n");
 fprintf(stderr, "      -r ... Program zobrazi relatini chybu.\n");
 fprintf(stderr, "      -p ... Program zobrazi relativni chybu v procentech.\n");
 fprintf(stderr, "   CHYBNA ROZHODNUTI:\n");
 fprintf(stderr, "      -err ... Zobrazi celkovy pocet chybnych rozhodnuti - ERR - \"ERRor decision\".\n");
 fprintf(stderr, "      -ers ... Zobrazi pocet chybnych rozhodnuti v reci  - ERS - \"ERror in Speech\".\n");
 fprintf(stderr, "      -erp ... Zobrazi pocet chybnych rozhodnuti v pauze - ERP - \"ERror in Pause\".\n");
 fprintf(stderr, "   DRUHY KRITERII:\n");
 fprintf(stderr, "      -nds ... Zobrazi chybu - NDS - \"Noise Detected as Speech\".\n");
 fprintf(stderr, "      -sdn ... Zobrazi chybu - SDN - \"Speech Detected as Noise\".\n");
 fprintf(stderr, "      -mis ... Zobrazi chybu - MIS - \"MIssed Speech\".\n");
 fprintf(stderr, "      -min ... Zobrazi chybu - MIN - \"MIssed Noise\".\n");
 fprintf(stderr, "      -ovb ... Zobrazi chybu - OVB - \"OVerlap at Back\".\n");
 fprintf(stderr, "      -ovf ... Zobrazi chybu - OVF - \"OVerlap at Front\".\n");
 fprintf(stderr, "      -trb ... Zobrazi chybu - TRB - \"TRuncation Back\".\n");
 fprintf(stderr, "      -trf ... Zobrazi chybu - TRF - \"TRuncation Front\".\n");
 fprintf(stderr, "      -bee ... Zobrazi chybu - BEE - \"Begin End Error\".\n");
 fprintf(stderr, "      -res ... Zobrazi chybu - RES - \"REverse Signal\".\n");
 fprintf(stderr, "   FORMAT ROZSIRENYCH KRITERII:\n");
 fprintf(stderr, "      -ae ... Program zobrazi prumernou chybu.\n");
 fprintf(stderr, "      -de ... Program zobrazi dobu trvani prumerne chyby.\n");
 fprintf(stderr, "          POVINNY PARAMETR:\n");
 fprintf(stderr, "             -fs frekvence ... Parametr frekvence slouzi k nastaveni vzorkovaci frekvence v Hz.\n");
 fprintf(stderr, "      -ms ... Zobrazovana doba trvani prumerne chyby je v ms.\n");   
 fprintf(stderr, "      -s  ... Zobrazovana doba trvani prumerne chyby je v s.\n");
 fprintf(stderr, "   ROZSIRENA KRITERIA:\n");
 fprintf(stderr, "      -ands ... Zobrazi chybu - ANDS - \"Average Noise Detect as Speech\".\n");
 fprintf(stderr, "      -asdn ... Zobrazi chybu - ASDN - \"Average Speech Detected as Noise\".\n");
 fprintf(stderr, "      -amis ... Zobrazi chybu - AMIS - \"Average MIssed Speech\".\n");
 fprintf(stderr, "      -amin ... Zobrazi chybu - AMIN - \"Average MIssed Noise\".\n");
 fprintf(stderr, "      -aovb ... Zobrazi chybu - AOVB - \"Average OVerlap at Back\".\n");
 fprintf(stderr, "      -aovf ... Zobrazi chybu - AOVF - \"Average OVerlap at Front\".\n");
 fprintf(stderr, "      -atrb ... Zobrazi chybu - ATRB - \"Average TRuncation Back\".\n");
 fprintf(stderr, "      -atrf ... Zobrazi chybu - ATRF - \"Average TRuncation Front\".\n");
 fprintf(stderr, "      -abee ... Zobrazi chybu - ABEE - \"Average Begin End Error\".\n");
 fprintf(stderr, "      -ares ... Zobrazi chybu - ARES - \"Average REverse Signal\".\n");
 fprintf(stderr, "   -all ... Zobrazi vsechna kriteria.\n");
 fprintf(stderr, "!!! Poradi ve vypisu zavisi na poradi zadavani parametru na prikazove radce !!!\n");
 fprintf(stderr, "Implicitni nastaveni: program vadcrit se spusti s temito parametry: -err -ers -erp -r -ae -ms\n");

 exit(1);
}

/***********************************************************************************************************
* Funkce: void ZobrazChybyAbsolutne()
* Popis :
*         Zobrazi chyby v absolutnim tvaru.
*/
void ZobrazChybyAbsolutne()
{
 int q = 1;

 if (Parametr_all)
   {
    for (q = 0; q < POCET_TYPU_CHYB; q++)
       {
        if (Chyba[q].APchyb != -1)
          {
           fprintf(stdout, "%i ", Chyba[q].APchyb);
          }
        else
          {
           fprintf(stdout, "%.3f ", Chyba[q].RPchyb);  // U daneho parametru neexistuji cela cisla, typ integer
          }
       }
   }
 else
   {
    //while ((AChyby[q]) && (q < POCET_TYPU_CHYB + 1))
    while (q < a)
         {
          if (AChyby[q] != -1)
            {
             fprintf(stdout, "%i ", AChyby[q]);
            }
          else
            {
             fprintf(stdout, "%.3f ", RChyby[q]);  // U daneho parametru neexistuji cela cisla, typ integer
            }
          q++;
         }
    }
 fprintf(stdout, "\n");
}

/***********************************************************************************************************
* Funkce: void ZobrazChybyVProcentech()
* Popis :
*         Zobrazi chyby v procentech.
*/
void ZobrazChybyVProcentech()
{
 int q = 1;

 if (Parametr_all)
   {
    for (q = 0; q < ZACATEK_PRUMERNYCH_CHYB; q++)
       {
        if (Chyba[q].RPchyb != -1)
          {
           fprintf(stdout, "%.3f ", Chyba[q].RPchyb * 100);
          }
        else
          {
           fprintf(stdout, "%i ", Chyba[q].APchyb);  // U daneho parametru neexistuji desetina cisla, typ float
          }
       }
   }
 else
   {
    //while ((AChyby[q]) && (q < ZACATEK_PRUMERNYCH_CHYB + 1))
    while (q < a)
         {
          if (RChyby[q] != -1)
            {
             fprintf(stdout, "%.3f ", RChyby[q] * 100);
            }
          else
            {
             fprintf(stdout, "%i ", AChyby[q]);  // U daneho parametru neexistuji desetina cisla, typ float
            }
          q++;
         }
   }
 fprintf(stdout, "\n");
}

/***********************************************************************************************************
* Funkce: void ZobrazChybyRelativne()
* Popis :
*         Zobrazi chyby v relativnim tvaru.
*/
void ZobrazChybyRelativne()
{
 int q = 1;
  
 if (Parametr_all)
   {
    for (q = 0; q < POCET_TYPU_CHYB; q++)
       {
        if (Chyba[q].RPchyb != -1)
          {
           fprintf(stdout, "%.3f ", Chyba[q].RPchyb);
          }
        else
          {
           fprintf(stdout, "%i ", Chyba[q].APchyb);
          }
       }
   }
 else
   {
    //while ((AChyby[q]) && (q < POCET_TYPU_CHYB + 1))
    while (q < a)
         {
          if (RChyby[q] != -1)
            {
             fprintf(stdout, "%.3f ", RChyby[q]);
            }
          else
            {
             fprintf(stdout, "%i ", AChyby[q]);
            }
          q++;
         }
   }
 fprintf(stdout, "\n");
}

/***********************************************************************************************************
* Funkce: void ZobrazVerziProgramu()
* Popis :
*         Zobrazi verzi aktualniho programu.
*/
void ZobrazVerziProgramu()
{
 fprintf(stdout, "vadcritcz %s, Napsal Milan Vaclavik\n\n", cvsRevision);
}
